> ## Documentation Index
> Fetch the complete documentation index at: https://apidocs.specurate.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Apply



## OpenAPI

````yaml /openapi.json patch /v1/workspaces/{workspaceId}/projects/{projectId}/item-slots/bulk-edit/components
openapi: 3.1.0
info:
  title: Specurate API
  description: ''
  version: 1.0.0
  contact: {}
servers:
  - url: https://app.specurate.com/api
    description: API Server
security: []
tags: []
paths:
  /v1/workspaces/{workspaceId}/projects/{projectId}/item-slots/bulk-edit/components:
    patch:
      tags:
        - Specification Component Bulk Edit
      summary: Apply
      operationId: SpecificationComponentBulkEditController_apply_v1
      parameters:
        - name: workspaceId
          required: true
          in: path
          schema:
            type: string
        - name: projectId
          required: true
          in: path
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/SpecificationComponentBulkApplyDto'
      responses:
        '200':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SpecificationBulkEditApplyResponseDto'
      security:
        - bearer: []
components:
  schemas:
    SpecificationComponentBulkApplyDto:
      type: object
      properties:
        parents:
          maxItems: 100
          type: array
          items:
            type: object
            properties:
              slotId:
                type: string
              slotVersion:
                type: integer
                exclusiveMinimum: 0
                maximum: 9007199254740991
              primaryItemId:
                anyOf:
                  - type: string
                  - type: 'null'
              primaryItemVersion:
                anyOf:
                  - type: integer
                    exclusiveMinimum: 0
                    maximum: 9007199254740991
                  - type: 'null'
            required:
              - slotId
              - slotVersion
              - primaryItemId
              - primaryItemVersion
            additionalProperties: false
        selectionMode:
          type: string
          const: components
        targets:
          minItems: 1
          maxItems: 100
          type: array
          items:
            type: object
            properties:
              componentId:
                type: string
              componentVersion:
                type: integer
                exclusiveMinimum: 0
                maximum: 9007199254740991
              catalogFamilyId:
                type: string
              catalogItemId:
                type: string
              catalogItemSourceId:
                anyOf:
                  - type: string
                  - type: 'null'
              links:
                minItems: 1
                maxItems: 100
                type: array
                items:
                  type: object
                  properties:
                    parentId:
                      type: string
                    parentItemId:
                      type: string
                    linkId:
                      type: string
                  required:
                    - parentId
                    - parentItemId
                    - linkId
                  additionalProperties: false
            required:
              - componentId
              - componentVersion
              - catalogFamilyId
              - catalogItemId
              - catalogItemSourceId
              - links
            additionalProperties: false
        fieldKey:
          type: string
          minLength: 1
          maxLength: 255
        value:
          anyOf:
            - type: string
            - type: number
            - type: boolean
            - type: array
              items:
                type: string
            - type: 'null'
        coreChangeIntent:
          type: string
          const: save_in_project
      required:
        - parents
        - targets
        - fieldKey
        - value
      additionalProperties: false
    SpecificationBulkEditApplyResponseDto:
      type: object
      properties:
        updatedCount:
          type: number
        slotIds:
          type: array
          items:
            type: string
        projectItemIds:
          type: array
          items:
            type: string
        affectedCatalogFamilyIds:
          type: array
          items:
            type: string
        affectedParentPiIds:
          type: array
          items:
            type: string
      required:
        - updatedCount
        - slotIds
        - projectItemIds
        - affectedCatalogFamilyIds
        - affectedParentPiIds
  securitySchemes:
    bearer:
      scheme: bearer
      bearerFormat: JWT
      type: http

````